#include "rapidjson/filereadstream.h"
#include "rapidjson/document.h"
#include <stdio.h>
#include <iostream>
#include <cstdio>

using namespace rapidjson;
using namespace std;

void main()
{
	FILE* fp = fopen("mytest.json", "rb"); // non-Windows use "r"
	const int bufferLength = 65536;
	char readBuffer[bufferLength] = {0,};
#if 0
	FileReadStream is(fp, readBuffer, sizeof(readBuffer));
	Document doc;
	doc.ParseStream(is);
	fclose(fp);
#else
	size_t fileSize = fread(readBuffer, 1, bufferLength, fp);
	fclose(fp);
	Document doc;
	doc.Parse(readBuffer);
#endif

	if(doc.HasMember("name"))
	{
		Value& v = doc["name"];
		cout << "name: " << v.GetString() << endl;
		cout << "age: " << doc["age"].GetInt() << endl;

		cout << "arr: ";
		const rapidjson::Value& arr = doc["arr"];
		for (SizeType i =  0; i < arr.Size(); i++)
		{
			cout << arr[i].GetInt() << "  ";
		}
		cout << endl;
	}
}