#include "rapidjson/filereadstream.h"
#include "rapidjson/document.h"
#include <fstream>
#include <stdio.h>
#include <iostream>
#include <string>
#include <cctype>
#include <cstdio>

using namespace rapidjson;
using namespace std;

static inline void ltrim_string(std::string &s)
{
    int fisrt_non_space = 0;
    for (int i = 0; i < s.size(); i++)
    {
        if (!std::isspace(s[i]))
        {
            fisrt_non_space = i;
            break;
        }
    }
    s = s.substr(fisrt_non_space);
}

std::string ParseFile(const std::string &file)
{
    std::ifstream f(file.c_str());
    if (!f.is_open())
    {
        cout << "Open json file failed." << endl;
        return "";
    }
    std::string content;
    std::string line;
    while (std::getline(f, line))
    {
        ltrim_string(line);
        if (line.find("//") == 0 || line.find("#") == 0)
        {
            continue;
        }
        content.append(line);
    }
    return content;
}

void main()
{
	std::string content = ParseFile("mytest_coment.json");
	Document doc;
    rapidjson::ParseResult bParseok = doc.Parse(content.c_str(), content.size());
    if (bParseok.IsError())
    {
        cout << "parse error !!!" << endl;
		return;
    }

	if(doc.IsArray())
	{
		cout << "is array  " << doc.Size() << endl;
		for (SizeType i =  0; i < doc.Size(); i++)
		{
			Value& v = doc[i];
			cout << "name:  " << v["name"].GetString() << endl;
		}
	}
}
